/*
///////////////////////////////////////////////////////////////////////////////////
       Version : WabModCheap 2.00
        Author : AloneTrio 
          Date : 11/03/2007  22:30
///////////////////////////////////////////////////////////////////////////////////
*/


#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <stdint.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#include "lptport.h"
#include "cn302.h"

int RW_WAIT = 100;
int C_WAIT = 1000;


int main(void)
{
//char *lastbuf ;
//uint8_t *typebuf;
//uint8_t* MF1 = NULL;
//uint8_t* MF2 = NULL;

uint8_t *monbuf;
uint8_t *monbuf2;
int tst=0;

monbuf = (char *)malloc(0x21);
monbuf2 = (char *)malloc(0x0C);

char wiimodel[0];
int  wii_memlocs;
int  wii_mediaflag;
int  wii_emuflag;
int  wii_di;
uint8_t wiiunlockcmd[4]={0x41,0x00,0x00,0x00};
uint8_t inquiry[0];

printf("            ۲      ۲   ۲ \n");
printf("            ۲     ۲    ۲  \n");
printf("                          \n");
printf("                        \n");
printf("                      \n");
printf("                        \n");
printf("                      \n");
printf("                      \n");
printf("Ŀ\n");
printf("                    - W e  A r e  B a c k -                  \n"); 
printf("Ĵ\n");
printf("                 .. : : WabModCheap 2.0 : : ..               \n");
printf("                                                             \n");
printf("+ Compatible DMS/D2A/D2B + Wii original + Wii Backup Native +\n");
printf("          + GC original + GC backup + GC HomeBrew +          \n");
printf("                                                             \n");
printf("soon : Max drive speed - OnTheFly Region Patching            \n");
printf("\n");


	if(lptport_init()==-1)
	{
		printf("\tCould not open parallel port driver\n");
	        return(-1);
	}
	atexit((void*)lptport_close);
	
	if (cn302_init(RW_WAIT,C_WAIT,C_WAIT) == -1){
		printf("\tSync failed! Please check your connections.\n");
		lptport_close();
	        return(-1);
	}
	atexit((void*)cn302_close);
	

// WII MODEL DETECTION -------------------------------------------------------------
	cn302_peek_byte(0x40BA06, wiimodel);
	printf("[+] WII Model Detection : ");
        if(wiimodel[0]==0x20){
	   printf("DMS/D2A\n");
	   wii_memlocs = 0x82b6;
	   wii_mediaflag = 0x8576;
	   wii_emuflag = 0x8598;
	   wii_di = 0x8308;
	}
	else{
	   printf("D2B\n");
   	   wii_memlocs = 0x82be;
  	   wii_mediaflag = 0x8580;
   	   wii_emuflag = 0x85A2;
   	   wii_di = 0x8312;
	} 

// UNLOCK WII MEM ------------------------------------------------------------------        
        cn302_write_block(wii_memlocs,0x4,wiiunlockcmd);	
	printf("[+] WII Memory Unlocked\n");

// WAIT FOR DISK INSERTED ---------------------------------------------------------
	printf("\nPlease Insert a Disk...\n\n");
	while(inquiry[0] != 0xD0){
		cn302_peek_byte(0x40BA06, inquiry);
	}	
	printf("[+] Disk Inserted\n");

// PATCHING W00T !! --------------------------------------------------------------
    	cn302_peek_byte(wii_mediaflag, inquiry);
	if((inquiry[0] & 0x10) == 0x10){
		printf("[+] Patching ...\n");
	        cn302_write_block(wii_memlocs,0x4,wiiunlockcmd);	
		cn302_poke_byte(wii_emuflag,0x04);
		cn302_poke_byte(wii_mediaflag,0x28);
		inquiry[0]=0;
		while(inquiry[0] != 0xF1){
                	cn302_peek_byte(0x40BA06, inquiry);
        	}
		cn302_poke_byte(wii_mediaflag,0x38);
	}        
// READING GAME NAME -------------------------------------------------------------
        printf("[+] Retrieving Game Name (experimental) : ");
	while ( tst < 250 ){
		cn302_read_block(wii_di, 0x0C, monbuf2);
		//cn302_read_block(0x4001A0, 0x21, monbuf);

		//printf("0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x-- %s\n",monbuf2[0],monbuf2[1],monbuf2[2],monbuf2[3],monbuf2[4],monbuf2[5],monbuf2[6],monbuf2[7],monbuf);

		if ((monbuf2[4] == 0x00) && (monbuf2[5] == 0x08) && (monbuf2[6] == 0x00) && (monbuf2[7] == 0x00)) {
			cn302_read_block(0x4001A0, 0x21, monbuf);
		}
		tst++;
	}
	tst=0;
	printf("\"%s\"\n\n",monbuf);

	printf("Giga Ultra Stealth Mode : We do not stay connected to wii anymore... ;)  \n");
	printf("Thanks for using this WAB Production. \n");
	return(1);
}
